(in-package :bio-graphics)

(defun square-test ()
  (with-canvas (:width 400 :height 400)
    (set-font (get-font (default-font)) 40)
    (set-rgb-fill 1.0 1.0 1.0)
    (clear-canvas)
    (rounded-rectangle 20 20 360 360 10 10)
    (stroke)
    (translate 200 200)
    (set-rgb-stroke 1 0 0)
    (set-rgb-fill 0 0 0)
    (draw-centered-string 0 -10 "Square")
    (stroke)
    (save-png "square.png")))

(defun circle-test ()
  (with-canvas (:width 400 :height 400)
    (set-font (get-font (default-font)) 40)
    (set-rgb-fill 1.0 1.0 1.0)
    (clear-canvas)
    (centered-circle-path 200 200 180)
    (stroke)
    (translate 200 200)
    (set-rgb-stroke 1 0 0)
    (set-rgb-fill 0 0 0)
    (draw-centered-string 0 -10 "circle")
    (stroke)
    (save-png "circle.png")))

(defun stream-test (stream)
  (with-canvas (:width 400 :height 400)
    (set-font (get-font (default-font)) 40)
    (set-rgb-fill 1.0 1.0 1.0)
    (clear-canvas)
    (centered-circle-path 200 200 180)
    (stroke)
    (translate 200 200)
    (set-rgb-stroke 1 0 0)
    (set-rgb-fill 0 0 0)
    (draw-centered-string 0 -10 "circle")
    (stroke)
    (save-png-stream stream)))


(defun feature (start end)
  (with-graphics-state
    (set-rgb-stroke 0 0 1.0)
    (rectangle start 0 (- end start) 1)
    (fill-and-stroke)))

(defun feature-test ()
  (with-canvas (:width 400 :height 400)
    (flet ((draw-feature (f)
	     (with-graphics-state
	       (scale (/ (- 400 20) 1000) 10)    
	       (funcall f))))

      (let ((features 
	     (list 
	      (lambda () (feature 300 700))
	      (lambda () (feature 500 800))
	      (lambda () (feature 300 600)
		      (feature 100 150) )
	      (lambda () (feature 1 1000)))))
	
	(set-rgb-fill 1.0 1.0 1.0)
	(set-rgb-stroke 0 0 0)
	(clear-canvas)
	
	(translate 10 0)
	(dolist (feature features)
	  (translate 0 30)
	  (draw-feature feature)))
      (save-png "feature.png"))))
  
